package com.example.scan_example;


import androidx.annotation.NonNull;

import android.os.Bundle;
import android.os.IScanListener;

import com.example.iscandemo.iScanInterface;

import io.flutter.embedding.android.FlutterActivity;
import io.flutter.embedding.engine.FlutterEngine;
import io.flutter.plugin.common.EventChannel;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugins.GeneratedPluginRegistrant;

// implements FlutterPlugin, MethodCallHandler
public class MainActivity extends FlutterActivity{

    private MethodChannel methodChannel;
    private EventChannel eventChannel;
    private EventChannel.EventSink _eventSink = null;

    private final static  String TAG = "iScanDemo";
    //定义接口操作对象
    public iScanInterface miScanInterface;

    public String resultStr;

    //定义数据回调接口
    private IScanListener scanResltListener = new IScanListener(){
        /**
         * @param data 条码数据
         * @param type 条码类型
         * @param decodeTime 解码耗时
         * @param keyDownTime 按键时间
         * @param imagePath 图片路径，注意：默认图片输出为关闭状态；
         *                                  如果需要条码图片需要打开图片输出选项。
         */
        @Override
        public void onScanResults(String data, final  int type, long decodeTime, long keyDownTime, String imagePath) {
//            Log.d(TAG, "onScanResults: data="+data);
//            Log.d(TAG, "onScanResults: type="+type);
//            Log.d(TAG, "onScanResults: decodeTime="+decodeTime);
//            Log.d(TAG, "onScanResults: keyDownTime="+keyDownTime);
//            Log.d(TAG, "onScanResults: imagePath="+imagePath);

            final String result="data:"+data+"\r\n"
                    +"type:"+type+"\n"
                    +"decodeTime:"+decodeTime+"\n"
                    +"keyDownTime:"+keyDownTime+"\n"
                    +"imagePath:"+imagePath+"\n";

            runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    if (type == 0){
                        resultStr = "无";
                    }else {
                        resultStr = data;
                    }
                    if (_eventSink != null) {
                        System.out.println(resultStr);
                        _eventSink.success(resultStr);
                    }
                }
            });
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
//
//        //初始化接口对象
//        miScanInterface = new iScanInterface(this);
//        //注册数据回调接口
//        miScanInterface.registerScan(scanResltListener);
    }

    @Override
    public void configureFlutterEngine(@NonNull FlutterEngine flutterEngine) {
        GeneratedPluginRegistrant.registerWith(flutterEngine);

        eventChannel = new EventChannel(flutterEngine.getDartExecutor().getBinaryMessenger(), "event_channel_event");
        eventChannel.setStreamHandler(new EventChannel.StreamHandler() {
            @Override
            public void onListen(Object o, EventChannel.EventSink eventSink) {
                _eventSink = eventSink;
            }
            @Override
            public void onCancel(Object o) {
                _eventSink = null;
            }
        });
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        //应用关闭后注销回调
        miScanInterface.unregisterScan(scanResltListener);
    }
}
